/*
   Draw nine instances of SimpleModel4 (where each instance
   of SimpleModel4 contains four instances of SimpleModel).
*/
import java.awt.Color;

public class ShowSimpleModel36
{
   public static void main(String[] args)
   {
      Model m4 = new SimpleModel4();

      Model nestedModels = new Model();

      nestedModels.addSubModel( m4 );

      for (int i = 0; i < 8; i++)
      {
         Model subModel = new Model();
         subModel.modelRotate( i*45.0, 0,0,1);
         subModel.modelTranslate(0, -11, 0);
         subModel.modelScale(0.5, 0.5, 0.5);
         subModel.addSubModel( m4 );
         nestedModels.addSubModel( subModel );
      }


      // Create the Scene object that we shall render
      Scene scene = new Scene();

      // Add the model to the Scene.
      scene.modelList.add(nestedModels);

      // Create a Camera object.
      Camera camera = new Camera();

      // Give the Camera a view matrix.
      camera.view2Identity();

      // Set up the camera's view frustum.
      double left   = -3.0;
      double right  =  3.0;
      double top    =  3.0;
      double bottom = -3.0;
      double near   =  1.0;
      double far    =  20.0;
      camera.projOrtho(left, right, bottom, top, near, far);

      // Set up the camera's location and orientation.
      double eyex=0,    eyey=0,    eyez=8;
      double centerx=0, centery=0, centerz=0;
      double upx=0,     upy=1,     upz=0;
      camera.viewLookAt(eyex,    eyey,    eyez,
                        centerx, centery, centerz,
                        upx,     upy,     upz);

      // Add the Camera to the Scene.
      scene.setCamera(camera);

      // Create a framebuffer to render our scene into.
      int vp_width  = 512;
      int vp_height = 512;
      FrameBuffer fb = new FrameBuffer(vp_width, vp_height);
      // Give the framebuffer a nice background color.
      fb.clearFB(java.awt.Color.lightGray);

      // Create a default rendering pipeline.
      SceneRender renderer = new SceneRender();


      for (int i = 0; i <= 36; i++)
      {
         nestedModels.model2Identity();
         nestedModels.modelScale(0.2, 0.2, 0.2);
         nestedModels.modelRotate(10*i, 0, 0, 1);
//         m4.model2Identity();
//         m4.modelRotate(10*i, 0, 0,1);
         // Render again.
         fb.clearFB(java.awt.Color.white);
         renderer.renderScene(scene, fb);
         fb.dumpFB2File(String.format("PPM_SimpleModel36_Frame%02d.ppm", i));
      }
   }
}